

package interfaceProofTree;
import javax.swing.event.*;
import javax.swing.*; // JPanel (entre otros)
import javax.swing.tree.*;

import proofTree.NodeInfo;
import proofTree.ProofTree;

public class  DDTMenuListener implements MenuListener {

 ProofTree tree;
 Oracle oracle;

 public DDTMenuListener(ProofTree theTree,Oracle theOracle) {
   tree = theTree;
   oracle = theOracle;
 } // constructor

  public void menuDeselected( MenuEvent evt ) {}
  public void menuCanceled( MenuEvent evt ) {}

 public void menuSelected( MenuEvent evt ) {
  String selected = ( (JMenuItem)evt.getSource()).getText();

    if (selected == "Node")
  	actionNode((JMenu)evt.getSource());

    if (selected == "Strategy")
  	actionStrategy((JMenu)evt.getSource());

  }

   private  void actionNode( JMenu menu) {
       // obtaing the selected node
       DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                                  tree.getLastSelectedPathComponent();
       if (node == null) {
           JOptionPane.showMessageDialog(null,"There is no selected node","DDT Information",JOptionPane.ERROR_MESSAGE);
           return;
        }

       NodeInfo nodeInfo =(NodeInfo)(node.getUserObject());
       int state = nodeInfo.getNodeState();


       for (int i=0; i<menu.getItemCount(); i++) {
            JCheckBoxMenuItem item = (JCheckBoxMenuItem) menu.getItem(i);
            item.setState(false);
       }

       JCheckBoxMenuItem item = (JCheckBoxMenuItem) menu.getItem(stateToItem(state));
       item.setState(true);



 } // actionNode

 private int stateToItem(int state) {
       int position=-1;
       switch(state) {
                  case NodeInfo.VALID:
		      position = 0;
                      break;

                  case NodeInfo.NONVALID:
		      position = 1;
                      break;

		  case NodeInfo.DONTKNOW:
		      position = 2;
                      break;

                  case NodeInfo.TRUSTED:
                      position = 3;
                      break;

                  case NodeInfo.BUGGY:
                      position = 4;
                      break;
             }  // switch
  return position;
 }

 // this method selects the current strategy option
 private  void actionStrategy( JMenu menu) {
     int strategy = oracle.getStrategy();
     JCheckBoxMenuItem itemNoStrategy = (JCheckBoxMenuItem) menu.getItem(0);
     JCheckBoxMenuItem itemTopDown = (JCheckBoxMenuItem) menu.getItem(1);
     JCheckBoxMenuItem itemDivideAndQuery = (JCheckBoxMenuItem) menu.getItem(2);
     JCheckBoxMenuItem itemCombine = (JCheckBoxMenuItem) menu.getItem(3);

     switch(strategy) {

     case Oracle.NO_STRATEGY :
        itemNoStrategy.setState(true);
	itemTopDown.setState(false);
        itemDivideAndQuery.setState(false);
	itemCombine.setState(false);
       break;
     case Oracle.TOP_DOWN_STRATEGY:
        itemNoStrategy.setState(false);
        itemTopDown.setState(true);
        itemDivideAndQuery.setState(false);
	itemCombine.setState(false);
       break;
     case Oracle.DIVIDE_AND_QUERY_STRATEGY:
        itemNoStrategy.setState(false);
        itemTopDown.setState(false);
        itemDivideAndQuery.setState(true);
	itemCombine.setState(false);
	break;
     case Oracle.COMBINED_STRATEGY:
        itemNoStrategy.setState(false);
        itemTopDown.setState(false);
        itemDivideAndQuery.setState(false);
	itemCombine.setState(true);
     }

  } // actionStrategy
} // DDTMenuListener
