package interfaceProofTree;
import java.io.*;
import java.util.Vector;

public class Entailment {
 Vector data = new Vector();

 // constructor
 // name: The name of the file with the entailment information
 public Entailment(String name) {
   readData(name);
 }

 // return a Vector with the elements that the parameter arrow entails
public Vector getEntails(String arrow) {
  boolean found = false;
  Vector result = new Vector(); // if the arrow doesn't entail any other arrow

  for (int  i=0; !found &&  i<data.size(); i++) {
      EntailData element = (EntailData)data.elementAt(i);

      if ( element.arrow.equals(arrow)) {
         found = true;
	 result = element;
      }
  } // for

  return result;

}


 // return a Vector with the elements that the parameter arrow entails
public Vector getEntailed(String arrow) {
  boolean found = false;
  Vector result = new Vector(); // if the arrow is not entailed by any other arrow

  for (int  i=0; !found &&  i<data.size(); i++) {
      EntailData element = (EntailData)data.elementAt(i);
      // check if 'arrow' is entailed by 'element.arrow'
      for (int j=0; j<element.size(); j++) {
            String entailed = (String)  element.elementAt(j);
	    if (entailed.equals(arrow))
	        result.addElement(element.arrow);
       } // for j
      } // for i

  return result;

}

private void  readData(String file) {
    File inputFile = new File(file);

    if (inputFile.exists() && inputFile.canRead()) {
         try{
             // read the text file
            String  data = readEntailmentInformation(inputFile);
	    // process the data from the first character
	    createEntailmentData(data,0);
         } catch(Exception e){
                e.printStackTrace();
		data = new Vector();
           }
    } // if
}

// reads the whole string contained in the file.
private  String readEntailmentInformation(File inputFile) {
      String inputString;
      try{
        FileInputStream input = new FileInputStream(inputFile);
        byte bt[] = new byte[(int) inputFile.length()];
        int totalBytes = input.read(bt);
        inputString = new String(bt);
        input.close();
      } catch (IOException e) {
                e.printStackTrace();
                inputString = new String("#error#");
        }

     return inputString;
   } // readTreeInformation

private void createEntailmentData(String inputString,int index) {
   // while there is more basic fact to consider ..
   while (index <inputString.length() &&  inputString.indexOf("#",index)!=-1) {
      	index = inputString.indexOf("#",index)+1;

   	// extract the basic fact
   	int endPos =  inputString.indexOf("#",index);
   	String arrow = new String(inputString.substring(index, endPos));
   	index = endPos+1;

   	// new element
  	EntailData d = new EntailData(arrow);
  	while(index <inputString.length() && inputString.charAt(index) != '#') {
   		endPos =  inputString.indexOf("#",index);
   		arrow = new String(inputString.substring(index, endPos));
   		index = endPos+1;
   		d.addElement(arrow);
    	}
    	data.addElement(d);
  }
} // createEntailment

}



class EntailData extends Vector{
 String arrow;
 public EntailData(String arrow) {
  this.arrow = arrow;
 }

 public String toString() {
   return arrow+" ==>  "+super.toString();
 }
}

