package interfaceProofTree;
import java.awt.*; // para Component...

import javax.swing.tree.*;
import javax.swing.*;

import proofTree.NodeInfo;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    public class MyRenderer extends DefaultTreeCellRenderer {
          ImageIcon nonvalidIcon,buggyIcon,validIcon,dontknowIcon,trustedIcon;

        public MyRenderer(ImageIcon theNonvalidIcon,
                      ImageIcon theValidIcon,
                      ImageIcon theBuggyIcon,
                      ImageIcon theDontknowIcon,
                      ImageIcon theTrustedIcon) {
        nonvalidIcon = theNonvalidIcon;
        validIcon    = theValidIcon;
        buggyIcon    = theBuggyIcon;
        dontknowIcon = theDontknowIcon;
        trustedIcon  = theTrustedIcon;
        }

        public Component getTreeCellRendererComponent(
                            JTree tree,
                            Object value,
                            boolean sel,
                            boolean expanded,
                            boolean leaf,
                            int row,
                            boolean hasFocus) {

            super.getTreeCellRendererComponent(
                            tree, value, sel,
                            expanded, leaf, row,
                            hasFocus);

            // convert the value into a NodeInfo variable
            DefaultMutableTreeNode node =
                    (DefaultMutableTreeNode)value;
            NodeInfo nodeInfo =
                    (NodeInfo)(node.getUserObject());
        
               
            if (nodeInfo.getNodeState()==NodeInfo.VALID) {
                setIcon(validIcon);
                setToolTipText("State: Valid. Select & right-click to change the state");
            }
            else if (nodeInfo.getNodeState()==NodeInfo.NONVALID) {
                   setIcon(nonvalidIcon);
                   setToolTipText("State: Non-valid. Select & right-click to change the state");
                 }
                 else if (nodeInfo.getNodeState()==NodeInfo.DONTKNOW) {
                         setIcon(dontknowIcon);
                         setToolTipText("State: Unknown. Select & right-click to change the state");
                      }
                      else if (nodeInfo.getNodeState()==NodeInfo.TRUSTED) {
                         setIcon(trustedIcon);
                         setToolTipText("State: Trusted. Select & right-click to change the state");
                      } else if (nodeInfo.getNodeState()==NodeInfo.BUGGY) {
                               setIcon(buggyIcon);
                               setToolTipText("State: Buggy");
                             }                             
          
        return this;
        }

    }

 