queens([N], L) :-
    length(L, N),
    domain(L, 1, N),
    constrain_all(L)
,
    labeling([], L)
.

constrain_all([]).
constrain_all([X|Xs]) :-
    constrain_between(X, Xs, 1),
    constrain_all(Xs).

constrain_between(X, [], N).
constrain_between(X, [Y|Ys], N) :-
    no_threat(X, Y, N),
    N1 is N+1,
    constrain_between(X, Ys, N1).

no_threat(X, Y, I) :-
    X   #\= Y,
    X+I #\= Y,
    X-I #\= Y.


