%% bench.pl
:- use_module(library(clpfd)).

benches([queens,smm,
	 five,
	 eq10,
	 eq20,
	 partit,
	 donald,
	 crypta,
	 alpha,
	 magicseq,
	 suudoku,
	 mm,
	 cars_ix,
	 bridge,
	 squares,
	 photo,
	 config,
	 golomb,
	 tsp,
	 router,
	 pythagor,
	 safe,
	 party,
	 magicsq,
	 bibd,
	 golf,
	 life]).

bench([]) :-
	format(user_error, 'Bench closed\n',[]).
bench([Goal|Goals]) :-
	format(user_error, 'Calling goal: ~w\n',[Goal]),
	statistics(runtime,_),
	call(Goal), !,
	statistics(runtime,[_,T]),
	format(user_error, 'Runtime: ~d\n',[T]),
	fd_statistics,
	nl(user_error),
	bench(Goals).

bench :-
	bench(
		[heur_queens([ff],_,8),
		 heur_queens([ff],_,16),
		 heur_queens([ff],_,32),
		 heur_queens([ff],_,64),
		 heur_queens([ff],_,128),
		 smm([leftmost],_),
		 smm_ix([leftmost],_),
		 five_house(_,[leftmost]),
		 eq10([bisect,max],_),
		 eq10_ix([bisect,max],_),
		 eq20([bisect,max],_),
		 eq20_ix([bisect,max],_),
		 partit([ff],8,_,_,_),
		 partit([ff,discrepancy(3)],16,_,_,_),
		 partit([ff,discrepancy(4)],24,_,_,_),
		 partit([ff,discrepancy(5)],32,_,_,_),
		 donald([ff,down],_),
		 donald_ix([ff,down],_),
		 crypta([ff,bisect],_),
		 crypta_ix([ff,bisect],_),
		 alpha([ffc,bisect],_),
		 alpha_ix([ffc,bisect],_),
		 magic_gcc(100,_,[ff]),
		 suudoku([ff],1,_),
		 suudoku([ff],2,_),
		 suudoku([ff],3,_),
		 suudoku([ff],4,_),
		 suudoku([ff],5,_),
		 suudoku([ff],6,_),
		 mm([6,5,6,3,2,3]),
		 findall(1,cars_ix([leftmost],_),_),
		 findall(1,cars_ix2([leftmost],_),_),
		 findall(1,cars_ix3([leftmost],_),_),
		 bridge_s(big,_,_),
		 bridge_p(big,_,_),
		 squares(dual,wcd,_,_),
		 squares(dual,disjoint,_,_),
		 % new additions
		 config_bb([],_,_),
		 config_restart([],_,_),
		 golomb([],10,_),
		 tsp(chip,_,_),
		 tsp(ilog,_,_),
		 \+route([ffc],72,1,27,174,1534),
		 photo_bb([min],5,1,_,_),
		 photo_bb([min],7,1,_,_),
		 pythagoras([ff],_),
		 safe([ff],_),
		 party([ff,discrepancy(2)]),
		 magic_square([bisect],4,_),
		 magic_square([bisect],5,_),
		 bibd(rl,13,104,24,3,4),
		 golf(8,4,7,[ff],bycol),
		 still_life(plain_mirror,12,12,76,_),
		 true
		 ]
	     ).

:- benches(Benches),
   ensure_loaded(Benches).

