/* Copyright(C) 1994-95, Swedish Institute of Computer Science */


/* [PM] 3.9.0 Tru64 FD_ZERO uses bzero without ensuring bzero is
   declared. Defining _OSF_SOURCE ensures that bzero is declared in
   <string.h> */
#ifndef _OSF_SOURCE
#define _OSF_SOURCE
#endif

#if !__NeXT__

#if 0                           /* [PM] 3.9.1 AIX 4.3.3. see if we can do without BSD compatibility */
#if _AIX
#define _BSD 1
#endif
#endif /* 0 */

#ifdef __WATCOMC__
#ifdef __NT__
#define SP_WIN32 1
#endif
#ifdef __OS2__
#define SP_OS2 1
#endif
#endif

#ifdef __BORLANDC__
#define SP_WIN32 1
#endif

#ifdef _MSC_VER
#define SP_WIN32 1
#endif

#ifdef __WIN32__
#define SP_WIN32 1
#endif

#if SP_WIN32
#include <windows.h>
#endif



#if 0 /*_MSC_VER || __GNUC__ && __WIN32__ */
#define Tcl_DoOneEvent _Tcl_DoOneEvent
#define Tcl_SetVar _Tcl_SetVar
#define Tk_Init _Tk_Init
#define Tk_MainWindow _Tk_MainWindow
#define Tk_DestroyWindow _Tk_DestroyWindow
#define Tk_MakeWindowExist _Tk_MakeWindowExist
#define Tk_GetNumMainWindows _Tk_GetNumMainWindows
#define TkWinGetAppInstance _TkWinGetAppInstance
#define TkWinXInit _TkWinXInit
#endif

#include <stdarg.h>             /* [PM] April 2000 before stdio.h fixes va_list issue on dec-osf */
#include <stdio.h>
#include <string.h>


#include <sys/types.h>
#if !SP_WIN32
#include <sys/time.h>           /* select et al in SUSv2 */
#include <unistd.h>             /* [PM] 3.9.1 needed for select on MacOS X 10.1, it seems. */
#include <sys/file.h>
#endif
#include <sicstus/sicstus.h>
#include <sicstus/config.h>

#if HAVE_STRINGS_H
#include <strings.h>            /* [PM] 3.9.1 for bzero which AIX 4.3.3 uses to define FD_ZERO */
#endif /* HAVE_STRINGS_H */

#if (__APPLE__ && __MACH__)     /* 3.10.1 MacOS X */

#define Cursor X11_Cursor       /* [PM] 3.10.1 needed to hide X11 Cursor type from the Quickdraw.h Cursor type */

#endif /* (__APPLE__ && __MACH__) */

#include <tk.h>

#if (__APPLE__ && __MACH__)     /* 3.10.1 MacOS X */

#undef Cursor

#endif /* (__APPLE__ && __MACH__) */

#if (__APPLE__ && __MACH__)     /* 3.10.1 MacOS X */

#ifndef USE_CPSEnableForegroundOperation
#error "USE_CPSEnableForegroundOperation should be zero or one/PM"
#endif /* USE_CPSEnableForegroundOperation */

#endif /* (__APPLE__ && __MACH__) */
/* [PM] after config.h */
#if (__APPLE__ && __MACH__)     /* 3.10.1 MacOS X */


#if USE_TransformProcessType    /* [PM] 3.11.1 */
#include <ApplicationServices/ApplicationServices.h>

#ifndef CHECK_IF_BUNDLED
#define CHECK_IF_BUNDLED 1
#endif

#elif USE_CPSEnableForegroundOperation

#include <CoreFoundation/CoreFoundation.h>     /* UInt32 */
#include <mach-o/dyld.h>        /* NSModule functions */

#ifndef CHECK_IF_BUNDLED
#define CHECK_IF_BUNDLED 1
#endif
#endif /* USE_CPSEnableForegroundOperation */


#if CHECK_IF_BUNDLED
#if 0 /* [PM] This is not compatible with the X headers included by Tk
         (/Library/Frameworks/Tk.framework/Headers/X11/X.h:53:
         conflicting types for `Cursor') */

#include <Carbon/Carbon.h>      /* [PM] 3.10.1 ProcessSerialNumber() */
#else
#include <ApplicationServices/ApplicationServices.h> /* [PM] 3.10.1 ProcessSerialNumber() (via HIServices/Processes.h) */
#endif /* 0 */
#endif /* CHECK_IF_BUNDLED */


#endif /* (__APPLE__ && __MACH__) */



#include "tcl.h"

#define TK_NUMVERSION (TK_MAJOR_VERSION*10+TK_MINOR_VERSION)

#if SP_WIN32 && TK_NUMVERSION <= 42
extern HINSTANCE 	TkWinGetAppInstance(void);
extern void 		TkWinXInit(HINSTANCE hInstance);
#endif

#if __WATCOMC__
#pragma aux (__cdecl) Tcl_DoOneEvent
#pragma aux (__cdecl) Tcl_SetVar
#pragma aux (__cdecl) Tk_Init
#pragma aux (__cdecl) Tk_MainWindow
#pragma aux (__cdecl) Tk_DestroyWindow
#pragma aux (__cdecl) Tk_MakeWindowExist
#pragma aux (__cdecl) Tk_GetNumMainWindows
#pragma aux (__cdecl) TkWinGetAppInstance
#pragma aux (__cdecl) TkWinXInit
#endif

#if  TK_NUMVERSION >= 41
#define tk_NumMainWindows Tk_GetNumMainWindows()
#define Tk_DoOneEvent Tcl_DoOneEvent
#endif

#if !SP_WIN32
static int SPCDECL tk_event_hook PROTOTYPE((int fd));
static void dummy PROTOTYPE((ClientData clientData, int mask));
#endif

/*   --------------------------------------------------------------  */


#if (__APPLE__ && __MACH__)     /* 3.10.1 MacOS X */

#if MACOSX_TCLTK_FRAMEWORK

#if DBG
#define ERROR_CODE(ECODE) do{fprintf(stderr, "ERROR: %s:%d error==%d\n", __FILE__, (int)__LINE__, (int)(ECODE));fflush(stderr);}while(0)
#define WARNING_CODE(ECODE) do{fprintf(stderr, "WARNING: %s:%d error==%d\n", __FILE__, (int)__LINE__, (int)(ECODE));fflush(stderr);}while(0)
#define GOTO_BARF do{ERROR_CODE(err); goto barf;}while(0)
#define WARN_ERR  WARNING_CODE(err)

#else  /* !DBG */
#define ERROR_CODE(ECODE)
#define WARNING_CODE(ECODE)
#define GOTO_BARF goto barf
#define WARN_ERR
#endif /* !DBG */


#if USE_CPSEnableForegroundOperation

/* Portions of CPS.h */
typedef struct CPSProcessSerNum
{
        UInt32          lo;
        UInt32          hi;
} CPSProcessSerNum;

extern OSErr    CPSGetCurrentProcess( CPSProcessSerNum *psn);
extern OSErr    CPSEnableForegroundOperation( CPSProcessSerNum *psn, UInt32 _arg2, UInt32 _arg3, UInt32 _arg4, UInt32 _arg5);
typedef OSErr   (*CPSEnableForegroundOperationPtr)( CPSProcessSerNum *psn, UInt32 _arg2, UInt32 _arg3, UInt32 _arg4, UInt32 _arg5);
extern OSErr    CPSSetFrontProcess( CPSProcessSerNum *psn);
extern OSErr    CPSSetProcessName(CPSProcessSerNum *psn, char const *name);


static OSErr MyCPSEnableForegroundOperation(CPSProcessSerNum *psn)
{
  char const *name = "_CPSEnableForegroundOperation";
  static CPSEnableForegroundOperationPtr cpsenableforegroundoperation = NULL;
  if (!cpsenableforegroundoperation)
    {
      if (NSIsSymbolNameDefined(name))
        {
          void *sym_addr;
          sym_addr = NSAddressOfSymbol(NSLookupAndBindSymbol(name));
          if (sym_addr)
            {
              cpsenableforegroundoperation = (CPSEnableForegroundOperationPtr)sym_addr;
            }
        }
    }
  if (cpsenableforegroundoperation)
    {
      /* [PM] 3.10.1 The arguments are from the net, no docs available anywhere */
      return (*cpsenableforegroundoperation)(psn,0x03,0x3C,0x2C,0x1103);
    }
  else
    {
      return -1;                /* CPSEnableForegroundOperationPtr not available */
    }
}

static int Aqua_EnableForegroundoperationCPS(char const *app_name)
{
  static int CPSEnableForegroundOperation_already_called = 0;
  CPSProcessSerNum psn;
  OSErr err = 0;
  if ((err = CPSGetCurrentProcess(&psn)) != 0) GOTO_BARF;
  if ((err = CPSSetProcessName(&psn, app_name)) != 0) GOTO_BARF;

  if (!CPSEnableForegroundOperation_already_called)
    {
      if ((err = MyCPSEnableForegroundOperation(&psn)) != 0)
        {
          /* [PM] 3.10.1 if CPSEnableForegroundOperation called more
             than once. Net wisdom thinks this is harmless. (Should
             not happen to us, though, unless the foreign resource is
             unloaded so that
             CPSEnableForegroundOperation_already_called gets
             reset. */
          if (err == 1010)   /* (1010 is kCGErrorInvalidOperation?) */
            {
              WARN_ERR;
              err = 0;
            }
          else
            {
              GOTO_BARF;
            }
        }
      CPSEnableForegroundOperation_already_called = 1;
    }
  /* [PM] 3.10.1 FIXME: Should we do this or not? I do not know what
     this does, this is what the code floating on the net does. */
  if ((err = CPSSetFrontProcess(&psn)) != 0) GOTO_BARF;

  return 0;
 barf:
  return err;

}

#endif /* USE_CPSEnableForegroundOperation */

#if USE_TransformProcessType
static int Aqua_EnableForegroundoperationTPT(char const *app_name)
{
  static int already_called = 0;
  OSStatus status = 0;
  ProcessSerialNumber const psn = { 0, kCurrentProcess };

  (void)app_name;

  if (!already_called)
    {
      already_called = 1; 

      status=TransformProcessType(&psn, kProcessTransformToForegroundApplication);
      (void)status;
      if (status!=noErr)
        {
          WARNING_CODE(status);
        }
    }
  return 0;
}
#endif /* USE_TransformProcessType */


/*
From Apple Carbon Tips and Tricks:

How to determine if my app is bundled? 

Here is a snippet of code which returns true if the currently running
application is running as a bundle. This code will work on Mac OS X as
well as CarbonLib 1.5 and later too (assuming you're running on 9.0 or
later), but for 8.6 you will need to use the techniques from Tech Note
2015.
*/

#if CHECK_IF_BUNDLED
static int iAmBundled(void)            /* a.k.a AmIBundled */
{
  FSRef processRef;
  FSCatalogInfo processInfo;
  int isBundled;
  OSErr err;
  ProcessSerialNumber psn = {0, kCurrentProcess};

  err = GetProcessBundleLocation(&psn, &processRef);
  if (err != noErr)
    {
      ERROR_CODE(err);
      return 0;
    }
  err = FSGetCatalogInfo(&processRef, kFSCatInfoNodeFlags, 
                         &processInfo, NULL, NULL, NULL);
  if (err != noErr)
    {
      ERROR_CODE(err);
      return 0;
    }
  isBundled = processInfo.nodeFlags & kFSNodeIsDirectoryMask;
  #if DBG
  fprintf(stderr, "DBG: %s:%d isBundled == %d\n", __FILE__, (int)__LINE__, (int)isBundled);fflush(stderr);
  #endif/* DBG */

  return isBundled;
}
#else  /* !CHECK_IF_BUNDLED */
#define iAmBundled() 0          /* dummy */
#endif /* !CHECK_IF_BUNDLED */


/* [PM] 3.10.1 Allow Aqua windows created by Aqua Tk to be brought to
   the front (e.g., when clicked on). Failure to perform this hack
   will give error messages like SetFrontProcess
   See internals.tex */
static int Aqua_EnableForegroundoperation(char const *app_name)
{

  #if USE_CPSEnableForegroundOperation
  return Aqua_EnableForegroundoperationCPS(app_name);
  #elif USE_TransformProcessType
  return Aqua_EnableForegroundoperationTPT(app_name);
  #else
  #error "cannot happen"
  #endif
}

#endif  /* MACOSX_TCLTK_FRAMEWORK */

#endif /* (__APPLE__ && __MACH__) */


/*   --------------------------------------------------------------  */

void tk_new(tInterp, app_name, screen_name, flags, tkversion)
     SP_term_ref tInterp;
     char *app_name, *screen_name;
     long flags;
     long tkversion;
{
  Tcl_Interp *interp;

  if ((tkversion == 40 && 40 < TK_NUMVERSION) ||
      (tkversion == 41 && 40 >= TK_NUMVERSION))
    SAVE_ERROR(SPTK_ERROR, "Wrong Tk version", tInterp, 0);
    
  GetInterp(tInterp, interp, 1);

  if (screen_name[0] == '\0')
#if SP_WIN32
/* Necessary ? */
    screen_name = "localhost:0";
#else
    screen_name = NULL;
#endif

#if TK_NUMVERSION < 41
  if (Tk_CreateMainWindow(interp, screen_name, app_name, "Tk") == NULL)
    SAVE_ERROR(SPTK_ERROR, interp->result, tInterp, 0);
#endif

  if (Tcl_AppInit(interp) == TCL_ERROR)
    SAVE_ERROR(SPTK_ERROR, Tcl_GetStringResult(interp), tInterp, 0);

#if TK_NUMVERSION >= 41
  {
    int tcl_argc = 1;
    char tcl_argv[256], *tap = tcl_argv;
    char buf[8];

    tcl_argv[0] = '\0';

    if (screen_name)
      {
	tcl_argc += 2;
	sprintf(tap, "-display %s", screen_name);
	tap += strlen(tap);
      }
    if (app_name[0] != '\0')
      {
	tcl_argc += 2;
	sprintf(tap, " -name \"%s\"", app_name);
      }
    sprintf(buf, "%d", tcl_argc);
    Tcl_SetVar(interp, "argc", buf, TCL_GLOBAL_ONLY);
    Tcl_SetVar(interp, "argv", tcl_argv, TCL_GLOBAL_ONLY);
  }
#endif

  if (Tk_Init(interp) == TCL_ERROR)
    SAVE_ERROR(SPTK_ERROR, Tcl_GetStringResult(interp), tInterp, 0);

#if !SP_WIN32
  if (flags & 1)
    {
      /* [PM] 3.9b5 the first arg to Tcl_CreateFileHandler is a file
         descriptor (STDIN_FILENO, i.e., zero). This means that
         Tcl_DoOneEvent will only return if there is a Tcl/Tk-event or
         if some input appears on STDIN_FILENO. However, STDIN_FILENO
         may be unrelated to the file descriptor passed to
         tk_event_hook!

         To summarize: If SICStus reads from a modeTTY stream that is
         not stdin then the Tcl/Tk read-hook will block until there is
         some input on STDIN_FILENO. This is unrelated to the fact
         that SICStus read hooks cannot work reliably (due to
         buffering within the stdio FILE structure).

       */

#if TK_NUMVERSION < 41  
      Tk_CreateFileHandler(0, TK_READABLE, dummy, (ClientData) 0);
#elif TK_NUMVERSION <= 42
      Tcl_CreateFileHandler(Tcl_GetFile((ClientData)0,TCL_UNIX_FD),
			    TCL_READABLE, dummy, (ClientData) 0);
#else  /* TK_NUMVERSION > 42 */
      Tcl_CreateFileHandler(0, TCL_READABLE, dummy, (ClientData) 0);
#endif  /* TK_NUMVERSION > 42 */
      SP_set_read_hook(tk_event_hook);
    }
#endif /* !SP_WIN32 */

#if (__APPLE__ && __MACH__)     /* 3.10.1 MacOS X */
  {
#if MACOSX_TCLTK_FRAMEWORK
#if (USE_CPSEnableForegroundOperation || USE_TransformProcessType)
    {
      int disable_aqua_hack = ((flags & 0x02)            /* 2 is disable_aqua_hack */
                               ||
                               getenv("SP_DISABLE_TCLTK_AQUA_HACK")/* another way to disable the hack */
                               );
      int enable_aqua_hack = ((flags & 0x04) /* 4 is enable_aqua_hack */
                              ||
                              getenv("SP_ENABLE_TCLTK_AQUA_HACK") /* if explicitly requested  */
                              );
      
      {
        if (!disable_aqua_hack)
          {
            if (enable_aqua_hack
                ||
                !iAmBundled() /* do it if not bundled (since bundled app do not need it) */
                )
              {
                Aqua_EnableForegroundoperation(app_name);
              }
          }
      }
    }
#endif /* (USE_CPSEnableForegroundOperation || USE_TransformProcessType) */
#endif/* MACOSX_TCLTK_FRAMEWORK */
  }
#endif /* (__APPLE__ && __MACH__) */


  local.tk_inited = 1;
  return;
  RAISE_ERROR("tk_new", 2);
}

/*   --------------------------------------------------------------  */

void tk_main_window(tInterp, tWindow)
     SP_term_ref tInterp;
     SP_term_ref tWindow;
{
  Tcl_Interp *interp;
  Tk_Window window;

  GetInterp(tInterp, interp, 1);

  if (!local.tk_inited)               /* [PM] May 2000 Workaround Tcl Stub vector not being initialized in Tk (PRM 1493) */
    {
      SAVE_ERROR(SPTK_ERROR, "Not a Tk enabled Tcl interpreter", tInterp, 0);
    }

  window = Tk_MainWindow(interp);
  ptr_to_wrapper(local.atm_window, window, tWindow);
  return;
  RAISE_ERROR("tk_main_window", 2);
}

/*   --------------------------------------------------------------  */

void tk_destroy_window(tWindow)
     SP_term_ref tWindow;
{
  Tk_Window window = (Tk_Window)wrapper_to_ptr(local.atm_window,tWindow);

  if (window == NULL || !local.tk_inited) /* [PM] !tk_inited for PRM 1493 */
    SAVE_ERROR(DOMAIN_ERROR, "tk_window", tWindow, 1);

  Tk_DestroyWindow(window);
  return;
  RAISE_ERROR("tk_destroy_window", 1);
}

/*   --------------------------------------------------------------  */

void tk_make_window_exist(tWindow)
     SP_term_ref tWindow;
{
  Tk_Window window = (Tk_Window)wrapper_to_ptr(local.atm_window,tWindow);;

  if (window == NULL || !local.tk_inited) /* [PM] !tk_inited for PRM 1493 */
    SAVE_ERROR(DOMAIN_ERROR, "tk_window", tWindow, 1);

  Tk_MakeWindowExist(window);
  return;
  RAISE_ERROR("tk_make_window_exist", 1);
}

/*   --------------------------------------------------------------  */

long tk_do_one_event1(flags)
     long flags;
{
  return Tk_DoOneEvent(flags);  /* a.k.a  Tcl_DoOneEvent */
}

void tk_do_one_event3(tInterp, flags, tEvent)
     SP_term_ref tInterp, tEvent;
     long flags;
{
  struct interp_data *interp_data =
    (struct interp_data *)wrapper_to_ptr(local.atm_interp, tInterp);

  if (interp_data == NULL)
    SAVE_ERROR(DOMAIN_ERROR, "tcl_interpreter", tInterp, 1);

  switch (put_event_queue(interp_data, FALSE, tEvent))
    {
    case 1:
      return;
    case 0:
      Tk_DoOneEvent(flags);
      if (put_event_queue(interp_data, FALSE, tEvent) >= 0)
	return;
    case -1:
      RAISE_ERROR("tk_do_one_event", 3);
    }
}

/*   --------------------------------------------------------------  */

#if !SP_WIN32

static int SPCDECL tk_event_hook(fd)
     int fd;
{
  fd_set dread;
  struct timeval to;

  if (tk_NumMainWindows > 0)
    {
      (void) Tk_DoOneEvent(0);
      FD_ZERO(&dread);
      FD_SET(fd, &dread);
      to.tv_sec = 0;
      to.tv_usec = 0;
      if (select(fd+1, &dread, (fd_set *)0, (fd_set *)0, &to) < 0)
	return -1;
      if (FD_ISSET(fd, &dread))
	return 1;
      else
	return 0;
    }
  else
    return 1;
}

/* This one is installed as a handler for stdin only to ensure there
   is an event generated when there is input ready.
 */
static void dummy(clientData, mask)
     ClientData clientData;
     int mask;
{
  (void)clientData;
  (void)mask;
}

#endif

/*   --------------------------------------------------------------  */

void tk_num_main_windows(tNum)
     SP_term_ref tNum;
{
  if (!local.tk_inited) /* [PM] !tk_inited for PRM 1493 */
    {
      SP_put_integer(tNum, 0);
    }
  else
    {
      SP_put_integer(tNum, tk_NumMainWindows);
    }
}

/*   --------------------------------------------------------------  */

void SPCDECL tk_initialize(when)
     int when;
{
  local.tk_inited = 0;

  tcl_initialize(when);
  (void)SP_register_atom(local.atm_window = SP_atom_from_string("$TkWindow"));
  /* Necessary to initialize the X-emulation layer */
#if SP_WIN32 && TK_NUMVERSION <= 42
  TkWinXInit(TkWinGetAppInstance());
#endif
}

void SPCDECL tk_deinitialize(when)
     int when;
{
#if !SP_WIN32
  SP_ReadHookProc *readhook = SP_set_read_hook(NULL);

  if (readhook != NULL && readhook != tk_event_hook)
    SP_set_read_hook(readhook);
#endif
  tcl_deinitialize(when);
  (void)SP_unregister_atom(local.atm_window);
}

#else
#include <sicstus/sicstus.h>

/* Dummie defs to allow uniform handling when only Tcl is available. */

void tk_new(tInterp, app_name, screen_name, flags, tkversion)
     SP_term_ref tInterp;
     char *app_name, *screen_name;
     long flags;
     long tkversion;
{}

void tk_main_window(tInterp, tWindow)
     SP_term_ref tInterp;
     SP_term_ref tWindow;
{}

void tk_destroy_window(tWindow)
     SP_term_ref tWindow;
{}

void tk_make_window_exist(tWindow)
     SP_term_ref tWindow;
{}

long tk_do_one_event1(flags)
     long flags;
{}

void tk_do_one_event3(tInterp, flags, tEvent)
     SP_term_ref tInterp, tEvent;
     long flags;
{}

void tk_num_main_windows(tNum)
     SP_term_ref tNum;
{}

void SPCDECL tk_initialize(when)
     int when;
{
  local.tk_inited = 0;
  tcl_initialize(when);
}

#endif /* !__NeXT__ */
